<?php
/**
 * Created by PhpStorm.
 * User: MATHEUSSILVA
 * Date: 26/03/2015
 * Time: 12:02
 */

namespace Folha\Logic\ObrigacaoLegal\RAIS;

use \Geral\Util\AcumuladorDeMensagens;

class Exception extends \Exception
{
    //TIPO DE EXCEPTION
    const EXCEPTION_ERRO = 10;
    const EXCEPTION_ALERTA = 11;

    //MENSAGENS DE EXCEPTION
    const ERRO_HIST_ESTRUT_RESP     = "Histórico da estrutura responsável pela RAIS não foi encontrado";
    const ERRO_HIST_PESSOA_RESP     = "Histórico da pessoa responsável pela RAIS não foi encontrado";
    const ERRO_EMAIL_RESPONS_RAIS   = "Não foi possível encontrar o e-mail para o (a) responsável pela RAIS";
    const ERRO_ENDER_RESPONS_RAIS   = "Não foi possível encontrar o endereço da estrutura responsável pela RAIS";
    const ERRO_TELEF_RESPONS_RAIS   = "Não foi possível encontrar o telefone da estrutura responsável pela RAIS";
    const ERRO_ESTRUTURAM_NAO_LOCA  = "Nenhuma estrutura foi retornada para o filtro de busca selecionado";
    const ERRO_ESTRUTURAH_NAO_LOCA  = "Não foi possível encontrar um histórico para a estrutura %1 - %2";
    const ERRO_INICIO_MAIOR_FINAL   = "O início deve ser menor que o valor final";
    const ERRO_FORMULARIO_RAIS      = "O formulário da RAIS não foi encontrado";
    const ERRO_VINCULO_SEM_PESSOA   = "Não existe cadastro de pessoa para o vínculo %1 - %2";
    const ERRO_PESSOA_SEM_HISTORICO = "Não foi possível encontrar histórico para a pessoa %1 - %2";
    const ERRO_VINCULO_SEM_HISTORIC = "Não foi possível encontrar histórico para o vínculo %1 - %2";
    const ERRO_ESCALATRAB_VINCULO   = "Não foi possível encontrar a escala de trabalho para o vínculo %1 - %2";
    const ERRO_OCUPACAO_VINCULO     = "Não foi possível encontrar a ocupação para o vínculo %1 - %2";
    const ERRO_TPDEMISSAO_VINCULO   = "Não foi possível encontrar o tipo de demissão para o vínculo %1 - %2";
    const ERRO_TPAMISSAO_VINCULO    = "Não foi possível encontrar o tipo de admissão para o vínculo %1 - %2";
    const ERRO_GERENCIAL_VINCULO    = "Não foi possível encontrar a estrutura gerencial para o vínculo %1 - %2";
    const ERRO_ALTSALARIAL_VINCULO  = "Não foi possível encontrar alguma alteração salarial para o vínculo %1 - %2";
    const ERRO_VINCULO_VINCULOEMPR  = "Não foi possível encontrar o vínculo empregatício para o vínculo %1 - %2";
    const ERRO_GERENCIAL_ENDERECO   = "Não foi possível encontrar o endereço para a estrutura gerencial %1 - %2";


    const ALERTA_ESTRUT_SEM_VINCUL  = "A estrutura %1 - %2 não possui vínculos";
    const ALERTA_TELEFONE_ESTRUTURA = "Não foi possível encontrar o telefone para a estrutura %1 - %2";
    const ALERTA_EMAIL_ESTRUTURA    = "Não foi possível encontrar o e-mail para a estrutura %1 - %2";
    const ALERTA_ENDERECO_ESTRUTURA = "Não foi possível encontrar o endereço para a estrutura %1 - %2";
    const ALERTA_MUNICIPIO_ESTRUTURA= "Não foi possível encontrar o municipio para a estrutura %1 - %2";
    const ALERTA_NACIONALID_INEXIST = "A nacionalidade da pessoa %1 - %2 não foi encontrada";
    const ALERTA_GRAU_INSTR_INEXIST = "A grau de instrução da pessoa %1 - %2 não foi encontrada";
    const ALERTA_OCUPACAO_SEM_CBO   = "O CBO da ocupação %1 não foi encontrada.";



    /**
     * Alterna entre uma erro ou acumula um alerta de exceção gerada.
     *
     * @param string $message
     * @param array $params
     * @param int $tipo
     *
     * @return Exception|bool
     *
     * $mensagem = "O erro aconteceu no P_PRIMEIRO quando P_SEGUNDO e causou P_TERCEIRO.";
     * $params = array(
     *                      'P_PRIMEIRO' => "parametro",
     *                      'P_SEGUNDO' => "parametro",
     *                      'P_TERCEIRO' => "parametro",
     *                 )
     *  $tipo = self::EXCEPTION_ERRO/self::EXCEPTION_ALERTA;
     */
    public static function newException($message, $params = array(), $tipo = self::EXCEPTION_ERRO)
    {
        foreach ($params as $key => $value) {
            $message = str_replace('%' . ($key + 1), $value, $message);
        }

        if ($tipo == self::EXCEPTION_ERRO) {
            return new self($message, self::EXCEPTION_ERRO);
        } else {
            $alertas = AcumuladorDeMensagens::getInstance();
            $alertas->addMensagem($message);
            return true;
        }
    }
}