var Dfe71000_sincronizacaoCTE_Controller = function(ScreenService, templateManager, ZhFilterPreferences) {
    
    this.cnpjOnChange = (widget) => {
        let inscricaoEstadual = widget.getField("CDINSCESTA");
        
        if(widget.currentRow.NRINSJURIEST) {
            inscricaoEstadual.dataSourceFilter.forEach( (data) => {
                if(data.name == 'CDEMPRESA')    data.value = widget.currentRow.CDEMPRESA;
                if(data.name == 'NRINSJURIEST') data.value = widget.currentRow.NRINSJURIEST;
            });
        }
        inscricaoEstadual.readOnly = !widget.currentRow.NRINSJURIEST;
        inscricaoEstadual.setValue('');
    };

    this.empresaOnChange = (widget) => {
        let cnpj = widget.getField("NRINSJURIEST");
        let cnpjFilter = cnpj.dataSourceFilter.filter(data => data.name === 'CDEMPRESA')[0];
        
        if(widget.currentRow.CDEMPRESA) cnpjFilter.value = widget.currentRow.CDEMPRESA; 
        
        cnpj.readOnly = !widget.currentRow.CDEMPRESA;
        cnpj.setValue('');
        this.cnpjOnChange(widget);
    };
    
    this.setDefaultFilter = function(widget) {
        ZhFilterPreferences.openFilterWidget(widget).then(response => {
            let widFilter = templateManager.container.getActiveWidget();
            let clearFilter = widFilter.actions.filter(action => action.name === 'clear')[0];
            
            clearFilter.shortcutKey = 'ctrl+backspace';
            clearFilter.tooltip = 'Limpar Filtro (CTRL + Backspace)';
            widFilter.applyDefaultValue();
            widFilter.reload();
        });
    };
    
    this.setFilterBeforeApply = (args) => {
        let filterRow = args.e.preference.FILTER_ROW;
        let dsFilter = args.owner.dataSourceFilter;
        let nrinsjurpesq = dsFilter.filter(data => data.name === 'NRINSJURPESQ')[0];
        let dtemissao = dsFilter.filter(data => data.name === 'DTEMISSAO')[0];
        let cdstatus = dsFilter.filter(data => data.name === 'CDSTATUS')[0];
        let nracessocte = dsFilter.filter(data => data.name === 'NRACESSOCTE')[0];
        
        nrinsjurpesq.value = filterRow.NRINSJURIEST;
        dtemissao.value = [filterRow.DTEMISSAO.formattedStart, filterRow.DTEMISSAO.formattedEnd];
        cdstatus.value = filterRow.CDSTATUS;
        args.e.preference.CUSTOM_FILTER_ROW = {};
        
        if(filterRow.NRACESSOCTE) {
            if(typeof(nracessocte) === 'undefined')
                dsFilter.push({name: "NRACESSOCTE", operator: "=", value: filterRow.NRACESSOCTE});
            else
                nracessocte.value = filterRow.NRACESSOCTE;
        }
        else if(nracessocte) {
            dsFilter.forEach( (data) => {
                if(data.name == 'NRACESSOCTE') dsFilter.splice(dsFilter.indexOf(data), 1);
            });
        }
    };
};

Configuration(function(ContextRegister) {
    ContextRegister.register("Dfe71000_sincronizacaoCTE_Controller", Dfe71000_sincronizacaoCTE_Controller);
});